import win32.windows;
import win32.commctrl;
import std.stdio;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.CommonControl;

class ToolTip {
  shared static  id=0  ;
  private HWND   hwnd  ;
  private HWND   phwnd ;
  int            style ;
  TOOLINFO       toolinfo ;
  private string tiptext ;

  this() {
    CommonControl cc = new CommonControl() ;

    style = TTS_ALWAYSTIP ;

    toolinfo.cbSize = TTTOOLINFOW_V1_SIZE ; //TOOLINFO.sizeof ;
    toolinfo.uFlags = TTF_SUBCLASS ;
    toolinfo.uId    = id ;
    toolinfo.hinst  = null ;
    toolinfo.lpszText = toUTFz!(wchar*)("\0") ;
    hwnd =null ;
    phwnd=null ;
    id++ ;
  }

  ~this(){
  }

  int setText(string tiptext){
    this.tiptext = tiptext ;
    return(0) ;
  }

  int setStyle(int style){
    this.style=style ;
    return(0) ;
  }

  int addStyle(int addstyle){
    this.style |= addstyle ;
    return(0) ;
  }

  int create(HWND phwnd){
    if( this.hwnd==null ){
      this.hwnd = CreateWindowEx( 0,
				  cast(wchar*)(TOOLTIPS_CLASS),
				  cast(wchar*)(null),
				  style,
				  CW_USEDEFAULT, CW_USEDEFAULT, 
				  CW_USEDEFAULT, CW_USEDEFAULT,
				  phwnd,
				  null, GetModuleHandle(null),
				  null ) ;
      if( this.hwnd==null ){
	return(-1) ;
      }
      toolinfo.hwnd = phwnd ;
    }
    return(0) ;
  }

  int setClientRect(){
    if( this.hwnd != null ){
      GetClientRect(toolinfo.hwnd, &toolinfo.rect) ;
      toolinfo.lpszText = toUTFz!(wchar*)(this.tiptext) ;
      SendMessage( this.hwnd, TTM_ADDTOOL, 0, cast(LPARAM)(&toolinfo) ) ;
      return(0) ;
    }
    return(-1) ;
  }
  
  int reNewClientRect(){
    if( this.hwnd != null ){
      GetClientRect(toolinfo.hwnd, &toolinfo.rect) ;
      SendMessage( this.hwnd, TTM_NEWTOOLRECT, 0, cast(LPARAM)(&toolinfo) ) ;
      return(0) ;
    }
    return(-1) ;
  }
  
}
